=== debian/changelog ===
apt-cacher-ng (0.7.18-1) unstable; urgency=medium

  * New upstream release
    + includes tmpfile for proper startup with systemd (closes: #720215)

 -- Eduard Bloch <blade@debian.org>  Tue, 20 Aug 2013 00:45:51 +0200

apt-cacher-ng (0.7.17-1) unstable; urgency=medium

  * New upstream version
  * Various meta changes, removed binutils-gold conflict (closes: #719428)
  * systemd service config integration (closes: #716810)

 -- Eduard Bloch <blade@debian.org>  Sun, 18 Aug 2013 23:09:40 +0200

apt-cacher-ng (0.7.16-1) unstable; urgency=medium

  * New upstream version

 -- Eduard Bloch <blade@debian.org>  Wed, 31 Jul 2013 23:36:07 +0200

apt-cacher-ng (0.7.15-1) unstable; urgency=medium

  * New upstream version
    + handles timeouts from stale connections correctly (closes: #717832)
    + fixes varios regressions from 0.7.14

 -- Eduard Bloch <blade@debian.org>  Sun, 28 Jul 2013 21:05:54 +0200

apt-cacher-ng (0.7.14-1) unstable; urgency=low

  * New upstream version
    + prevents background looping (closes: #703296)
    + stop spamming apt-cacher.err when verbosity is not set to debug mode
      (closes: #714146)
  * Remove system user account with bare passwd tools where adduser package
    has been removed before purging apt-cacher-ng (LP: #1185547)

 -- Eduard Bloch <blade@debian.org>  Sat, 20 Jul 2013 10:55:07 +0200

apt-cacher-ng (0.7.13-1) unstable; urgency=medium

  * New upstream release
  * using Ubuntu config optimization added in the last version only where curl
    or wget are available and added curl or wget to Suggests (closes: #698466)
  * working around adduser failure on certain systems (closes: #706382)
  * added basic support for avahi publishing contributed by Lissandro,
    thanks! (closes: #704790)

 -- Eduard Bloch <blade@debian.org>  Tue, 21 May 2013 20:23:51 +0200

apt-cacher-ng (0.7.12-1) experimental; urgency=low

  * New upstream release
    + adds filename patterns for mirrors.txt (LP: #1020995)
    + adds options to configure pipeline behavior (LP: #1097952)
  * Using Ubuntu's mirrors.txt service to get a better fallback backend list
  * minor postinst fixes to deal with trailing spaces in modification checks

 -- Eduard Bloch <blade@debian.org>  Sat, 12 Jan 2013 20:15:14 +0100
