=== debian/control ===
--- 
+++ 
@@ -2,15 +2,15 @@
 Section: net
 Priority: optional
 Maintainer: Eduard Bloch <blade@debian.org>
-Build-Depends: debhelper (>= 7.2.3), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev, lsb-base (>> 3.0-6), dh-systemd
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev, lsb-base (>> 3.0-6), po-debconf, libssl-dev
+Standards-Version: 3.9.5
 Homepage: http://www.unix-ag.uni-kl.de/~bloch/acng/
 
 Package: apt-cacher-ng
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
 Pre-Depends: dpkg (>= 1.15.6)
-Recommends: perl (>> 5.8), ed, avahi-daemon
+Recommends: ed, avahi-daemon
 Conflicts: logrotate (<< 3.8.0)
 Suggests: doc-base, libfuse2 (>= 2.5), curl | wget
 Description: caching proxy server for software repositories
