## apt-cacher-ng 0.7.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -74,6 +74,19 @@
    MESSAGE("XZ (liblzma) not found or not working, disabling support")
    SET(HAVE_LZMA )
 ENDIF(HAVE_LZMA)
+SET(CMAKE_REQUIRED_LIBRARIES "")
+
+SET(SSL_LIB_LIST ssl crypto)
+SET(CMAKE_REQUIRED_LIBRARIES "${SSL_LIB_LIST}")
+SET(TESTSRC "#include \"${CMAKE_SOURCE_DIR}/include/testssl.h\"")
+CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_SSL)
+IF(HAVE_SSL)
+   list(APPEND AcngLdList "${SSL_LIB_LIST}")
+ELSE(HAVE_SSL)
+   MESSAGE("OpenSSL not found or not working, disabling support")
+   SET(HAVE_SSL )
+   SET(SSL_LIB_LIST )
+ENDIF(HAVE_SSL)
 SET(CMAKE_REQUIRED_LIBRARIES "")
 
 SET(CMAKE_REQUIRED_LIBRARIES wrap)
@@ -207,60 +220,13 @@
    endif(NOT HAVE_TR1_MEMORY)
 endif(NOT HAVE_BOOST_SMARTPTR)
 
-SET(TESTSRC "
-#include <dlfcn.h>
-int main(int argc, char **argv)
-{
-  return dlsym(dlopen(*argv, RTLD_LAZY), *argv) ?0:1;
-}
-")
 SET(CMAKE_REQUIRED_LIBRARIES dl)
-CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_DLOPEN)
-SET(CMAKE_REQUIRED_LIBRARIES "")
-
-SET(TESTSRC "
-#include <pthread.h>
-#include <errno.h>
-pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
-pthread_mutex_t mx = PTHREAD_MUTEX_INITIALIZER;
-
-void* stop_it(void *)
-{
-   pthread_mutex_lock(&mx);
-   pthread_cond_broadcast(&cond);
-   pthread_mutex_unlock(&mx);
-   return NULL;
-}
-
-int main(void)
-{
-   // no problem with small type
-   const struct timespec timeout = {9223372036854775807L, 12345};
-   if(sizeof(timeout.tv_sec) < 8)
-      return 0;
-   for(int i=0;i<30;++i)
-   {
-      pthread_mutex_lock(&mx);
-      pthread_t thr;
-      if(pthread_create(&thr,0,stop_it,0))
-         return -1;
-      switch(pthread_cond_timedwait(&cond, &mx, &timeout))
-      {
-         case EINTR:
-            continue; // loaded system, or killed by user?
-         case 0:
-            return 0; // correctly awaken = good
-         default:
-            return 1; // buggy implementation
-      }
-      pthread_mutex_unlock(&mx);
-      pthread_join(thr, 0);
-   }
-   return -2;
-}
-")
+CHECK_CXX_SOURCE_COMPILES("#include \"${CMAKE_SOURCE_DIR}/include/testdlopen.h\"" HAVE_DLOPEN)
+SET(CMAKE_REQUIRED_LIBRARIES "")
+
+# maybe enable workaround for platforms with a weird implementation
 SET(CMAKE_REQUIRED_LIBRARIES pthread)
-CHECK_CXX_SOURCE_RUNS("${TESTSRC}" PTHREAD_COND_TIMEDWAIT_TIME_RANGE_OK)
+CHECK_CXX_SOURCE_RUNS("#include \"${CMAKE_SOURCE_DIR}/include/testpthread.h\"" PTHREAD_COND_TIMEDWAIT_TIME_RANGE_OK)
 SET(CMAKE_REQUIRED_LIBRARIES "")
 
 
@@ -321,9 +287,9 @@
    # message("uhm: ${acngfs_cflags} -- ${fuse_LDFLAGS} -- ${HAVE_DLOPEN}")
    SET_TARGET_PROPERTIES(acngfs PROPERTIES COMPILE_FLAGS "${acngfs_cflags}" )
    if(HAVE_DLOPEN)
-      TARGET_LINK_LIBRARIES(acngfs dl pthread)
+      TARGET_LINK_LIBRARIES(acngfs dl pthread ${SSL_LIB_LIST})
    else(HAVE_DLOPEN)
-      TARGET_LINK_LIBRARIES(acngfs ${fuse_LDFLAGS})
+      TARGET_LINK_LIBRARIES(acngfs ${fuse_LDFLAGS} ${SSL_LIB_LIST})
    endif(HAVE_DLOPEN)
 
    IF(HAVE_WL_AS_NEEDED)
@@ -336,8 +302,8 @@
 endif(fuse_FOUND AND HAVE_FUSE_25)
 
 
-######################################
-# all checks done, save configuration    #
-######################################
+#######################################
+# all checks done, save configuration #
+#######################################
 
 CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/acsyscap.h.in" "${CMAKE_BINARY_DIR}/acsyscap.h")
