=== debian/changelog ===
apt-cacher-ng (0.7.26-1ubuntu0.1) trusty; urgency=medium

  [ Rolf Leggewie ]
  * backport appstream support from upstream (LP: #1547431).

  [Stefan Bader]
  * backport support for by-hash index files (LP: #1568754).

 -- Stefan Bader <stefan.bader@canonical.com>  Mon, 11 Apr 2016 15:28:48 +0200

apt-cacher-ng (0.7.26-1) unstable; urgency=medium

  * New upstream version
    + fixes the link action for quick forced file expiration (closes: #736684)
    + fixes incorrect percent escaping in some cases (thanks! closes: #737268)
    + adds gentoo_mirrors.default, config should work now (closes: #736579)
  * reconsidered purging strategy, only remove files in the default location
    because when the user changed the location manually to an external folder
    then the data there better should not be destroyed (also closes: #736684)
  * added http.debian.net as another special host like cdn.d.n (closes: #741272)
  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. Closes: #733087
  * [Debconf translation updates]
  * Russian (Yuri Kozlov).  Closes: #736847
  * Danish (Joe Hansen).  Closes: #736876
  * Brazilian Portuguese (Adriano Rafael Gomes).  Closes: #737468
  * French (Jean-Baka Domelevo Entfellner).  Closes: #737714
  * Basque (Joseba Goitia Gandiaga).  Closes: #738021
  * Czech (Miroslav Kure).  Closes: #738355
  * Italian (Beatrice Torracca).  Closes: #738574
  * Japanese (Hideki Yamane (Debian-JP)).  Closes: #738724
  * Polish (Michał Kułach).  Closes: #738746
  * Portuguese (Pedro Ribeiro).  Closes: #738790
  * Spanish (Matías A. Bellone).  Closes: #739799
  * German (Eduard Bloch)

 -- Eduard Bloch <blade@debian.org>  Sat, 22 Mar 2014 14:20:56 +0100
