=== debian/rules ===
#!/usr/bin/make -f

TGT=$(CURDIR)/debian/apt-cacher-ng
CDIR=$(TGT)/etc/apt-cacher-ng

%:
	dh $@ --parallel --with systemd

override_dh_install:
	dh_install $(test -e build/acngfs || echo -Xacngfs)
	cp systemd/apt-cacher-ng.service debian
	cp systemd/apt-cacher-ng.conf debian/apt-cacher-ng.tmpfile
	install -m 755 expire-caller.pl $(TGT)/usr/lib/apt-cacher-ng

override_dh_installinit:
	dh_installinit -- defaults 18

override_dh_compress:
	dh_compress -X.pdf

override_dh_clean:
	dh_clean
	rm -f debian/apt-cacher-ng.service debian/apt-cacher-ng.tmpfile
	debconf-updatepo

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog
