## apt-cacher-ng 0.7.27

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,59 +9,108 @@
 INCLUDE_DIRECTORIES(. ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR} "include")
 
 # minimum prqs
-list(APPEND AcngLdList pthread z bz2)
+list(APPEND AcngLdList pthread)
 
 INCLUDE(CheckIncludeFiles)
 INCLUDE(CheckCXXSourceCompiles)
 INCLUDE(CheckCXXSourceRuns)
 INCLUDE(CheckIncludeFiles)
 
-# I don't need -rdynamic, thanks!
-SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
-SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
-
-# common required flags
-SET(FLAGS_MIN " -pthread -Wall -D_FILE_OFFSET_BITS=64 ")
+# common required flags to be used later for CMAKE_REQUIRED_FLAGS and the build,
+# CXXFLAGS (via initial CMAKE_CXX_FLAGS) can override them
+SET(FLAGS_MIN " -pthread -g -O2 -Wall -Wextra -Wno-unused-parameter -D_FILE_OFFSET_BITS=64 ${CMAKE_CXX_FLAGS}")
+# same for linker flags, imported from LDFLAGS environment var
+SET(LDFLAGS_MIN "${CMAKE_EXE_LINKER_FLAGS}")
+
+message("Initial CXX flags: ${FLAGS_MIN}")
+message("Initial linker flags: ${LDFLAGS_MIN}")
 
 IF(CMAKE_SYSTEM MATCHES "Darwin")
    SET(FLAGS_MIN " ${FLAGS_MIN} -D_DARWIN_C_SOURCE ")
 ENDIF(CMAKE_SYSTEM MATCHES "Darwin")
+
+SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN}")
+
+# Various feature checks
 CHECK_INCLUDE_FILES ("sys/param.h;sys/mount.h" HAVE_SYS_MOUNT_H)
 CHECK_INCLUDE_FILES ("sys/vfs.h" HAVE_SYS_VFS_H)
 
-#SET(CMAKE_REQUIRED_FLAGS " -std=gnu++0x ")
-#CHECK_CXX_SOURCE_COMPILES("int main() {return 0;}" NEEDS_GNU_0x)
-#if(NEEDS_GNU_0x)
-#   SET(FLAGS_MIN " ${FLAGS_MIN} -std=gnu++0x ")
-#endif(NEEDS_GNU_0x)
-
+if(USE_CXX11)
+# if the compiler knows the switch, use it, otherwise try to work without it
+SET(CXX11_TESTSRC "struct z{int a=3;}; int main(){int a[3];for(auto x:a) return x;}")
+
+# if the compiler knows the switch, use it, otherwise try to work without it
+SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} -std=c++11 ")
+CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" SET_CXX11_FLAGS)
+if(SET_CXX11_FLAGS)
+   SET(FLAGS_MIN ${CMAKE_REQUIRED_FLAGS})
+
+# also look for a very specific cygwin bug
+SET(GNU11_BUGSRC "
+#include <cstdio>
+int main() { char buf[20]; return snprintf(buf,3,0); }
+")
+CHECK_CXX_SOURCE_COMPILES("${GNU11_BUGSRC}" HAS_NOGNU11BUG)
+if(NOT HAS_NOGNU11BUG)
+message("- WARNING: this compiler seems to have an old bug with missing definitions, trying to workaround. See http://cygwin.com/ml/cygwin/2012-04/msg00140.html for details.")
+   SET(FLAGS_MIN " ${CMAKE_REQUIRED_FLAGS} -std=gnu++11 " )
+endif(NOT HAS_NOGNU11BUG)
+
+
+else(SET_CXX11_FLAGS)
+   SET(CMAKE_REQUIRED_FLAGS ${FLAGS_MIN})
+   CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" CXX11_IS_DEFAULT)
+   IF(NOT CXX11_IS_DEFAULT)
+      message(FATAL_ERROR "- Error: failed to configure compiler for C++11 support. For GCC, version 4.7 or newer is required.")
+   ENDIF(NOT CXX11_IS_DEFAULT)
+endif(SET_CXX11_FLAGS)
+
+endif(USE_CXX11)
+
+#if(NOT ADDDEBUGSRC)
+#SET(CMAKE_REQUIRED_FLAGS "${FLAGS_MIN} -flto")
+#SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN} -flto ")
+#CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" USE_LTO)
+#if(USE_LTO)
+#   SET(FLAGS_MIN ${CMAKE_REQUIRED_FLAGS})
+#   SET(LDFLAGS_MIN ${CMAKE_EXE_LINKER_FLAGS})
+#else(USE_LTO)
+#   SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN}")
+#endif(USE_LTO)
+#endif(NOT ADDDEBUGSRC)
+
+
+SET(CMAKE_REQUIRED_FLAGS ${FLAGS_MIN})
+SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN}  -Wl,--as-needed ")
+CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" USE_WLASNEEDED)
+if(USE_WLASNEEDED)
+   SET(LDFLAGS_MIN ${CMAKE_EXE_LINKER_FLAGS})
+else(USE_WLASNEEDED)
+   SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN}")
+endif(USE_WLASNEEDED)
 
 #INCLUDE(FindZLIB) # broken, hangs for 10 seconds
 # header check should be enough, gzip should be everywhere nowadays
 #CHECK_INCLUDE_FILES("gzip.h" HAVE_ZLIB)
 FIND_PATH(HAVE_ZLIB zlib.h )
-if(NOT HAVE_ZLIB)
-   message(FATAL_ERROR "apt-cacher-ng requires gzip library and development files ${HAVE_ZLIB}")
-endif(NOT HAVE_ZLIB)
+if(HAVE_ZLIB)
+	list(APPEND AcngLdList z)
+	INCLUDE_DIRECTORIES(${HAVE_ZLIB})
+else(HAVE_ZLIB)
+   message(FATAL_ERROR "- apt-cacher-ng requires gzip library and development files ${HAVE_ZLIB}")
+endif(HAVE_ZLIB)
 
 INCLUDE(FindBZip2)
 if (BZIP2_FOUND)
    SET(HAVE_LIBBZ2 1)
    MARK_AS_ADVANCED(HAVE_LIBBZ2)
+	INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
+	list(APPEND AcngLdList bz2)
 else (BZIP2_FOUND)
-   message(FATAL_ERROR "apt-cacher-ng requires bzip2 library and development files")
+   message("- apt-cacher-ng requires bzip2 library and development files for bz2 format support")
 endif (BZIP2_FOUND)
 
-INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
-
-SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} -Wl,--as-needed")
-SET(TESTSRC "int main() {return 0;}")
-CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_WL_AS_NEEDED)
-
-# this flags are set to common base for the rest of the tests
-SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} ")
-
-
+SET(CMAKE_REQUIRED_FLAGS ${FLAGS_MIN})
 SET(CMAKE_REQUIRED_LIBRARIES lzma)
 SET(TESTSRC "
 #include <lzma.h>
@@ -71,7 +120,7 @@
 IF(HAVE_LZMA)
    list(APPEND AcngLdList lzma)
 ELSE(HAVE_LZMA)
-   MESSAGE("XZ (liblzma) not found or not working, disabling support")
+   MESSAGE("- XZ (liblzma) not found or not working, disabling support")
    SET(HAVE_LZMA )
 ENDIF(HAVE_LZMA)
 SET(CMAKE_REQUIRED_LIBRARIES "")
@@ -83,7 +132,7 @@
 IF(HAVE_SSL)
    list(APPEND AcngLdList "${SSL_LIB_LIST}")
 ELSE(HAVE_SSL)
-   MESSAGE("OpenSSL not found or not working, disabling support")
+   MESSAGE("- OpenSSL not found or not working, disabling support")
    SET(HAVE_SSL )
    SET(SSL_LIB_LIST )
 ENDIF(HAVE_SSL)
@@ -98,17 +147,21 @@
 IF(HAVE_LIBWRAP)
    list(APPEND AcngLdList wrap)
 ELSE(HAVE_LIBWRAP)
-   MESSAGE("libwrap development files not usable, disabling support")
+   MESSAGE("- libwrap development files not usable, disabling support")
    SET(HAVE_LIBWRAP)
 ENDIF(HAVE_LIBWRAP)
 SET(CMAKE_REQUIRED_LIBRARIES "")
 
-
+if(CYGWIN)
+message("- Not using wordexp on Cygwin, not reliable")
+set(HAVE_WORDEXP FALSE)
+else()
 SET(TESTSRC "
 #include <wordexp.h>
 int main(int argc, char **argv) { wordexp_t p; return wordexp(*argv, &p, 0); }
 ")
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_WORDEXP)
+endif()
 
 SET(TESTSRC "
 #include <glob.h>
@@ -222,12 +275,21 @@
 
 SET(CMAKE_REQUIRED_LIBRARIES dl)
 CHECK_CXX_SOURCE_COMPILES("#include \"${CMAKE_SOURCE_DIR}/include/testdlopen.h\"" HAVE_DLOPEN)
-SET(CMAKE_REQUIRED_LIBRARIES "")
 
 # maybe enable workaround for platforms with a weird implementation
 SET(CMAKE_REQUIRED_LIBRARIES pthread)
 CHECK_CXX_SOURCE_RUNS("#include \"${CMAKE_SOURCE_DIR}/include/testpthread.h\"" PTHREAD_COND_TIMEDWAIT_TIME_RANGE_OK)
+
+
+##################################
+# All checks done, start building
+
 SET(CMAKE_REQUIRED_LIBRARIES "")
+SET(CMAKE_REQUIRED_FLAGS ${FLAGS_MIN})
+
+# I don't need -rdynamic, thanks!
+SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
+SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
 
 
 FILE(GLOB SRCS "${CMAKE_SOURCE_DIR}/source/*.cc")
@@ -237,12 +299,10 @@
 
 SET_TARGET_PROPERTIES(apt-cacher-ng PROPERTIES COMPILE_FLAGS ${FLAGS_MIN})
 
-
 ADD_EXECUTABLE(in.acng client/client.cc)
 SET_TARGET_PROPERTIES(in.acng PROPERTIES COMPILE_FLAGS ${FLAGS_MIN})
 
-IF(HAVE_WL_AS_NEEDED)
-SET_TARGET_PROPERTIES(in.acng apt-cacher-ng PROPERTIES LINK_FLAGS  -Wl,--as-needed)
+#IF(HAVE_WL_AS_NEEDED)
 # funny hack, link with gcc and avoid libstdc++/libm (since no STL parts used
 # there). However, it needs to be investigated - the alternative linking makes
 # the binary 40kb larger, might include higher relocation costs and bigger
@@ -250,7 +310,7 @@
 # server process.
 #TARGET_LINK_LIBRARIES(in.acng supc++)
 #SET_TARGET_PROPERTIES(in.acng PROPERTIES LINKER_LANGUAGE C)
-ENDIF(HAVE_WL_AS_NEEDED)
+#ENDIF(HAVE_WL_AS_NEEDED)
 
 
 ############################################
@@ -274,7 +334,7 @@
 #include <fuse.h>
 int main() { return 0; }
 ")
-SET(CMAKE_REQUIRED_FLAGS ${fuse_cflags})
+SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} ${fuse_cflags}")
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FUSE_25)
 
 if(fuse_FOUND AND HAVE_FUSE_25)
@@ -292,18 +352,8 @@
       TARGET_LINK_LIBRARIES(acngfs ${fuse_LDFLAGS} ${SSL_LIB_LIST})
    endif(HAVE_DLOPEN)
 
-   IF(HAVE_WL_AS_NEEDED)
-      SET_TARGET_PROPERTIES(acngfs PROPERTIES LINK_FLAGS  -Wl,--as-needed)
-   ENDIF(HAVE_WL_AS_NEEDED)
-
-
 else(fuse_FOUND AND HAVE_FUSE_25)
-   message("FUSE not found or incompatible, not building acngfs")
+   message("- FUSE not found or not compatible, not building acngfs")
 endif(fuse_FOUND AND HAVE_FUSE_25)
 
 
-#######################################
-# all checks done, save configuration #
-#######################################
-
-CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/acsyscap.h.in" "${CMAKE_BINARY_DIR}/acsyscap.h")
