=== debian/changelog ===
apt-cacher-ng (0.7.27-1~bpo70+1) wheezy-backports; urgency=low

  * Update of the Wheezy backport

 -- Eduard Bloch <blade@debian.org>  Sun, 24 Aug 2014 16:38:41 -0700

apt-cacher-ng (0.7.27-1) unstable; urgency=medium

  * New upstream release
    + Includes fix of CVE-2014-4510, package patch dropped
  * Moved avahi-daemon to Suggests (LP: #1259191)

 -- Eduard Bloch <blade@debian.org>  Thu, 17 Jul 2014 21:10:25 +0200

apt-cacher-ng (0.7.26-2~bpo70+1) unstable; urgency=low

  * Wheezy backport, changes only from 0.7.25-1~bpo70+1

 -- Eduard Bloch <blade@debian.org>  Sat, 28 Jun 2014 13:54:12 +0200

apt-cacher-ng (0.7.26-2) unstable; urgency=high

  * Do not print the submitted (raw) file path in the response body of a 403
    message (CVE-2014-4510)

 -- Eduard Bloch <blade@debian.org>  Tue, 24 Jun 2014 19:19:29 +0200

apt-cacher-ng (0.7.25~bpo70+1) wheezy-backports; urgency=low

  * Updated wheezy backport

 -- Eduard Bloch <blade@debian.org>  Mon, 03 Feb 2014 22:11:29 +0100
