=== debian/control ===
--- 
+++ 
@@ -10,9 +10,9 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
 Pre-Depends: dpkg (>= 1.15.6)
-Recommends: ed, avahi-daemon
+Recommends: ed
 Conflicts: logrotate (<< 3.8.0)
-Suggests: doc-base, libfuse2 (>= 2.5), curl | wget
+Suggests: doc-base, libfuse2 (>= 2.5), curl | wget, avahi-daemon
 Description: caching proxy server for software repositories
  Apt-Cacher NG is a caching proxy for downloading packages from Debian-style
  software repositories (or possibly from other types).
