=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 CDIR=$(TGT)/etc/apt-cacher-ng
 
 %:
-	dh $@ --parallel --with systemd
+	dh $@ --parallel
 
 override_dh_install:
 	dh_install $(test -e build/acngfs || echo -Xacngfs)
